#ifndef __lcd__
#define __lcd__

void LCD_Init (void);
//fonction d'initialisation de l'afficheur LCD
//ne positionne pas les controleur ni le curseur

void LCD_Write_Command (unsigned char Data);
//Fonction qui permet d'envoyer une instruction  l'afficheur LCD
//envoyer 0x40 a 0x7F pour selectionner la colonne
//envoyer 0xB8 a 0xBF pour selectionner la ligne
//envoyer 0x3E pour eteindre ou 0x3F pour allumer.

void LCD_Send_Data (unsigned char Data);
//Fonction qui permet d'envoyer un caractre  l'afficheur LCD

void LCD_Clear (void);
//Fonction pour effacer l'cranc
//ne positionne pas le curseur apres utilisation.

void LCD_GotoXY (unsigned char X, unsigned char Y);
//Fonction pour positionner le curseur a un endroit cibl de l'cranc
//X correspond a la colonne ( dit adresse ) et Y a la ligne ( dit page ).

void LCD_PutChar (char ch);
//permet d'afficher les caractere a partir de la bibliothque Font_5x7.h

unsigned char LCD_ReadData (void);
//permet de lire une donne affiche (sur le curseur courant)

void LCD_PutPixel (unsigned char X, unsigned char Y);
//allume un pixel sur l'cranc  la position X,Y
//X correspond a la colonne (verticale), Y a la ligne (horizontale)

#endif
