#pragma config WDT = OFF	// Pas de watchdog
#pragma config OSC = HS		// HS pour un quartz de 20MHz
#include <p18f452.h>
#include "GameGirl.h"
#include "lcd.h"
#include <delays.h>
#include "space.h"

#define TIR 0xFF	//graphisme du tir
#define VITTIR 4	//vitesse du tir (plus le nombre est grand plus c'est lent

void main(void)
{	//DECLARATIONS DES VARIABLES LOCALES//
	unsigned char i;	//variable pour les 'for'
	unsigned char position = 50; 	//position du joueur (50 au debut de la partie)
	unsigned char YTIR = 255;	 	//position en Y du tir en nombre de page (255 = pas de tir )
	unsigned char XTIR = 0;			//position en X du tir
	unsigned char YTIREN = 0;	 	//position en Y du tir ennemi en nombre de page (255 = pas de tir )
	unsigned char XTIREN = 0;		//position en X du tir ennemi
	unsigned char NoTIRennemi = 1;	//numero de l'ennemi qui va tirer	
	unsigned char PixelViser = 0;	//variable indiquant le numro du pixel de n'ennemi vis (0 = rat)
	unsigned char NoEnnemi = 0;		//variable indiquant le numro de l'ennemi vis (de dauche a droite)
	unsigned char LIGNE1[16]={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};		//ennemis ligne 1
	unsigned char LIGNE2[16]={1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};		//ennemis ligne 2
	unsigned char TimeTIR = 0;		//variable permettant une gestion de la vitesse du tir


	//INITIALISATIONS//
	ConfigProcessor ();		//configuration des ports du micro
	LCD_Init();				//initialise l'afficheur LCD
	LCD_BACKLIGHT=1;		//allume le rtroclairage
	LCD_CSA = 0;			//selection le controleur B
	LCD_CSB = 1;			//page de gauche
	LCD_Write_Command(0xB8);//place le curseur sur la ligne 0
	LCD_Write_Command(0x40);//place le curseur sur la colone 0

	while(1)
	{
		//GESTION DE L'AFFICHAGE//
		//NOTE : ON NE FAIT PAS LCD_CLEAR POUR GAGNER EN VITESSE//
		AfficherEnnemis(LIGNE1,LIGNE2);	//on affiche les ennemi vivants
		CrerJoueur(position);			//on affiche le joueur

		//GESTION DE LA POSITION DU JOUEUR//
		if (Joystick_X()>256) position=position-2;	//on deplace le joueur de 2pixel
		if (Joystick_X()<-256) position=position+2;	//en fonction du joystick
		
		//si on arrive a l'extremit de l'ecranc on peut passer a l'autre extremit
		if (position > 125) position = 119;	
		//si la position est tres elev alors on a decrementer un nombre petit sur un unsigned char
		if (position > 119) position = 0; // 128-8 = 120 est la position max
		//si la position exede le maximum affichable alors on revien en pisition 0

		//GESTION D'UN TIR DU JOUEUR//

		TimeTIR++;	//incrmentation du temps entre chaque tir

		if ( !button_blue && YTIR==255 )//si on appui sur le boutton bleu et qu'il n'y a pas de tir
		{	XTIR = position+4;			//on crer des coordonne pour le tir
			YTIR = 6;					//pour qu'il soit trait ensuite
		}
	
		if ( YTIR < 7 && !(TimeTIR%VITTIR))	
		//si il y a un tir (7 est la page du vaisseau) et que le temps entre chaque tir est coul. 
		{	LCD_GotoXY(XTIR,YTIR);		//on va a la position du TIR
			LCD_Send_Data(TIR);			//et on affiche son graphisme
			if (YTIR<7)				//si le tir n'est pas au dessus du vaisseau
				{	LCD_GotoXY(XTIR,YTIR+1);	//on va a la position prcdente du tir
					LCD_Send_Data(0);			//et on l'efface
				}
			YTIR--;		//on decrmente la position du tir pour qu'il monte.
		}

		//GESTION D'UN TIR ENNEMI//
		
		NoTIRennemi = NoTIRennemi+1;	//on incrmente continuellement le numro de l'ennemi qui tire
		if (NoTIRennemi>16) NoTIRennemi=0;	//si ce nombre dpasse 15 on revien a 0

		if ( YTIREN==0 && (LIGNE1[NoTIRennemi]!=0 || LIGNE2[NoTIRennemi]!=0))
		//si il n'y a pas de tir ennemi et que l'ennemi qui doit tirer est vivant
		{	XTIREN = NoTIRennemi%16*8+4;	//on crer des coordonne pour le tir ennemi
			YTIREN = 2;						//pour qu'il soit trait ensuite
		}
		
		if ( YTIREN > 0 && !(TimeTIR%(VITTIR*2)))	
		//si il y a un tir (7 est la page du vaisseau) et que le temps entre chaque tir est coul. 
		{	LCD_GotoXY(XTIREN,YTIREN);	//on va a la position du TIR ennemi
			LCD_Send_Data(TIR);			//et on affiche son graphisme
			if (YTIREN>1)				//si le tir n'est pas au dessous d'un vaisseau ennemi
				{	LCD_GotoXY(XTIREN,YTIREN-1);	//on va a la position prcdente du tir
					LCD_Send_Data(0);			//et on l'efface
				}
			YTIREN++;		//on incrmente la position du tir pour qu'il descende
		}

		//ES CE QU'UN ENNEMI A ETE TOUCHE ?//
		NoEnnemi = XTIR /8;		//pour chaque 8 pixel de position on change d'ennemi
		PixelViser = XTIR %8;	//si PixelViser vaut 0 alors on est tomber sur le seul pixel vide.

		if ( YTIR == 1 && PixelViser !=0 && LIGNE2[NoEnnemi] ==1)
		//si un tir se trouve sur la deuxieme ligne de vaisseau
		//et qu'il n'est pas a cot d'un ennemi eventuel
		//et que le vaisseau eventuel est vivant.
		{	LIGNE2[NoEnnemi] = 0;//on met a 0 le bit du vaisseau correspond
			LCD_GotoXY(XTIR,YTIR+1);	//on va a la position du TIR
			LCD_Send_Data(0);			//et on l'efface
			YTIR =255;					//pour annuler ce tir
		}
		
		if ( YTIR == 0 && PixelViser !=0 && LIGNE1[NoEnnemi] ==1)
		//si un tir se trouve sur la deuxieme ligne de vaisseau
		//et qu'il n'est pas a cot d'un ennemi eventuel
		//et que le vaisseau eventuel est vivant.
		{	LIGNE1[NoEnnemi] = 0;//on met a 0 le bit du vaisseau correspond
			LCD_GotoXY(XTIR,YTIR+1);	//on va a la position du TIR
			LCD_Send_Data(0);			//et on l'efface
			YTIR =255;					//pour annuler ce tir
		}

		//ES CE QUE LE JOUEUR A ETE TOUCHE ?//
		
		if ( YTIREN == 8 && XTIREN>position+1 && XTIREN<position+7 )
		//si un tir se trouve sur ligne du joueur (la ligne du tir est incrmenter avant affichage)
		//et qu'il est sur le joueur
		{	while (button_red)
			{
				LCD_GotoXY(28,4);
				CrerEnnemis();
				LCD_PutChar ('G');	
				LCD_PutChar ('A');	
				LCD_PutChar ('M');	
				LCD_PutChar ('E');	
				LCD_GotoXY(68,4);
				LCD_PutChar ('O');	
				LCD_PutChar ('V');	
				LCD_PutChar ('E');
				LCD_PutChar ('R');
				CrerEnnemis();		//le joueur a perdu (GAME OVER)
			}		
		}

		if ( YTIREN == 8 && (XTIREN<position+1 || XTIREN>position+7) )
		//si un tir se trouve sur ligne du joueur (la ligne du tir est incrmenter avant affichage)
		//et qu'il est a cot du joueur
		{	LCD_GotoXY(XTIREN,YTIREN-1);	//on va a la position du TIR
			LCD_Send_Data(0);				//et on l'efface
			YTIREN =0;						//pour annuler ce tir
		}

		//CONDITIONS DE VICTOIRE//
		if (Victoire(LIGNE1,LIGNE2))	//si on a gagner on affiche un message :"GAME WIN"
		{	while(button_red)
			{	LCD_GotoXY(28,4);
				CrerEnnemis();
				LCD_PutChar ('G');	
				LCD_PutChar ('A');	
				LCD_PutChar ('M');	
				LCD_PutChar ('E');	
				LCD_GotoXY(68,4);
				LCD_PutChar ('W');	
				LCD_PutChar ('I');	
				LCD_PutChar ('N');
				CrerEnnemis();
			}		
		}
	}
}			
		
