#include "space.h"
#include "lcd.h"

/*
001234567
0........
1........
2...XXX..
3.XXXXXXX
4.X.XXX.X
5....X...
6........
7........
*/
const char Ennemi[8]=
{0x0,0x18,0x08,0x1C,0x3C,0x1C,0x08,0x18};
//tableau de valeurs permettant d'afficher un ennemi a l'ecranc

/*
001234567
0........
1........
2....X...
3.X.XXX.X
4.XXXXXXX
5...XXX..
6........
7........
*/
const char Joueur[8]=
{0x0,0x18,0x10,0x38,0x3C,0x38,0x10,0x18};
//tableau de valeurs permettant d'afficher le joueur a l'cranc



void CrerEnnemis (void)
{	unsigned char i;
	for(i=0;i<8;i++) LCD_Send_Data(Ennemi[i]);

}

void AfficherEnnemis (unsigned char L1[], unsigned char L2[])
//on est obliger de proceder par 4 fois car il faut changer de controleur
//au milieu de l'cranc
{	unsigned char i,j;

	LCD_GotoXY(0,0); //debut ligne 1
	for(i=0;i<8;i++) //pour les 8 premier vaisseau ligne 1
		if(L1[i]) CrerEnnemis();
		else for(j=0 ; j<8 ; j++) LCD_Send_Data(0);
		//on crer un ennemi si il est vivant (valeur =1)

	LCD_GotoXY(64,0); //fin ligne 1
	for(i=8;i<16;i++) //pour les 8 vaisseau suivant ligne 1
		if(L1[i]) CrerEnnemis();
		else for(j=0 ; j<8 ; j++) LCD_Send_Data(0);
		//on crer un ennemi si il est vivant (valeur =1)

	LCD_GotoXY(0,1); //debut ligne 2
	for(i=0;i<8;i++) //pour les 8 premier vaisseau ligne 2
		if(L2[i]) CrerEnnemis();
		else for(j=0 ; j<8 ; j++) LCD_Send_Data(0);
		//on crer un ennemi si il est vivant (valeur =1)

	LCD_GotoXY(64,1); //fin ligne 2
	for(i=8;i<16;i++) //pour les 8 vaisseau suivant ligne 2
		if(L2[i]) CrerEnnemis();
		else for(j=0 ; j<8 ; j++) LCD_Send_Data(0);
		//on crer un ennemi si il est vivant (valeur =1)
}

void CrerJoueur (unsigned char position)
{	unsigned char i;
	LCD_GotoXY(0,7);	//aller sur le debut de la page 7 (en bas de l'ecranc)
	
	for (i=0;i<64;i++) LCD_Send_Data(0);	
	LCD_GotoXY(64,7);	//pour changer de controleur
	for (i=0;i<64;i++) LCD_Send_Data(0);
	//permet d'effacer toute la derniere ligne ( fonction a developer ).

	for(i=0;i<8;i++) 
	{	LCD_GotoXY(position+i,7);	//on affiche le joueur
		LCD_Send_Data(Joueur[i]);	//sur les 8 octect suivant sa position
	}

}

unsigned char Victoire(unsigned char L1[], unsigned char L2[])
{	unsigned char i, gagner = 1;	//si rien ne l'empeche on auras gagner
	for (i=0; i<16 && gagner==1; i++) if (L1[i]==1 || L2[i]==1) gagner=0;
	//si un seul des vaisseau est vivant alors on a pas encore gagner
	return gagner;
}

